#ifndef __NTDDK_EX__H__
#define __NTDDK_EX__H__

typedef enum _SYSTEMINFOCLASS {
    SystemBasicInfo,                    //0
    SystemProcessorInfo,                //1
    SystemPerformanceInfo,              //2
    SystemTimeInfo,                     //3
    SystemPathInfo,                     //4
    SystemProcessThreadInfo,            //5
    SystemServiceDescriptorTableInfo,   //6
    SystemIoConfigInfo,                 //7
    SystemProcessorTimeInfo,            //8
    SystemNtGlobalFlagInfo,             //9
    SystemNotImplemented1,              //10
    SystemModuleInfo,                   //11
    SystemResourceLockInfo,             //12
    SystemNotImplemented2,              //13
    SystemNotImplemented3,              //14
    SystemNotImplemented4,              //15
    SystemHandleInfo,                   //16
    //TODO
    SystemObjectInformation,            //17
    //TODO
    SystemPageFileInformation,          //18
    SystemInstructionEmulationInfo,     //19
    SystemNotUsed1,                     //20
    SystemCacheInfo,                    //21
    SystemPoolTagInfo,                  //22
    SystemProcessorScheduleInfo,        //23
    SystemDpcInfo,                      //24
    SystemNotImplemented5,              //25
    SystemLoadSystemImage,              //26    //Callable only from Kernel mode
    SystemUnloadSystemImage,            //27    //Callable only from Kernel mode
    SystemTimerInfo,                    //28
    SystemNotImplemented6,              //29
    SystemNotImplemented7,              //30
    SystemNotImplemented8,              //31
    SystemCrashDumpSectionInfo,         //32
    SystemProcessorFaultCountInfo,      //33
    SystemCrashDumpStateInfo,           //34
    SystemDebuggerInfo,                 //35
    SystemThreadSwitchCounters,         //36
    SystemQuotaInfo,                    //37
    SystemLoadDriverInfo,               //38
    SystemPrioritySeparation,           //39
    SystemNotImplemented9,              //40
    SystemNotImplemented10,             //41
    SystemNotUsed6,                     //42
    SystemNotUsed7,                     //43
    SystemTimeZoneInfo,                 //44
    SystemLookasideInfo,                //45
} SYSTEMINFOCLASS;


NTSYSAPI
NTSTATUS
NTAPI
ZwQuerySystemInformation(
    IN SYSTEMINFOCLASS SystemInfoClass,
    OUT PVOID SystemInfoBuffer,
    IN ULONG SystemInfoBufferSize,
    OUT PULONG BytesReturned OPTIONAL
);

typedef struct _SYSTEM_MODULE_ENTRY
{
  ULONG  Unused;
  ULONG  Always0;
  PVOID  ModuleBaseAddress;
  ULONG  ModuleSize;
  ULONG  Unknown;
  ULONG  ModuleEntryIndex;
  USHORT ModuleNameLength;
  USHORT ModuleNameOffset;
  CHAR   ModuleName [256];
} SYSTEM_MODULE_ENTRY, * PSYSTEM_MODULE_ENTRY;

typedef struct _SYSTEM_MODULE_INFORMATION
{
    ULONG               Count;
    SYSTEM_MODULE_ENTRY Module [1];
} SYSTEM_MODULE_INFORMATION, *PSYSTEM_MODULE_INFORMATION;

typedef unsigned short  WORD;
typedef unsigned int    BOOL;
typedef unsigned long   DWORD;
typedef unsigned char   BYTE;


typedef struct _IMAGE_DOS_HEADER {      // DOS .EXE header
    WORD   e_magic;                     // Magic number
    WORD   e_cblp;                      // Bytes on last page of file
    WORD   e_cp;                        // Pages in file
    WORD   e_crlc;                      // Relocations
    WORD   e_cparhdr;                   // Size of header in paragraphs
    WORD   e_minalloc;                  // Minimum extra paragraphs needed
    WORD   e_maxalloc;                  // Maximum extra paragraphs needed
    WORD   e_ss;                        // Initial (relative) SS value
    WORD   e_sp;                        // Initial SP value
    WORD   e_csum;                      // Checksum
    WORD   e_ip;                        // Initial IP value
    WORD   e_cs;                        // Initial (relative) CS value
    WORD   e_lfarlc;                    // File address of relocation table
    WORD   e_ovno;                      // Overlay number
    WORD   e_res[4];                    // Reserved words
    WORD   e_oemid;                     // OEM identifier (for e_oeminfo)
    WORD   e_oeminfo;                   // OEM information; e_oemid specific
    WORD   e_res2[10];                  // Reserved words
    LONG   e_lfanew;                    // File address of new exe header
} IMAGE_DOS_HEADER, *PIMAGE_DOS_HEADER;

typedef struct _IMAGE_FILE_HEADER {
    WORD    Machine;
    WORD    NumberOfSections;
    DWORD   TimeDateStamp;
    DWORD   PointerToSymbolTable;
    DWORD   NumberOfSymbols;
    WORD    SizeOfOptionalHeader;
    WORD    Characteristics;
} IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER;

typedef struct _IMAGE_DATA_DIRECTORY {
    DWORD   VirtualAddress;
    DWORD   Size;
} IMAGE_DATA_DIRECTORY, *PIMAGE_DATA_DIRECTORY;
#define IMAGE_NUMBEROF_DIRECTORY_ENTRIES    16


typedef struct _IMAGE_OPTIONAL_HEADER {
    //
    // Standard fields.
    //

    WORD    Magic;
    BYTE    MajorLinkerVersion;
    BYTE    MinorLinkerVersion;
    DWORD   SizeOfCode;
    DWORD   SizeOfInitializedData;
    DWORD   SizeOfUninitializedData;
    DWORD   AddressOfEntryPoint;
    DWORD   BaseOfCode;
    DWORD   BaseOfData;

    //
    // NT additional fields.
    //

    DWORD   ImageBase;
    DWORD   SectionAlignment;
    DWORD   FileAlignment;
    WORD    MajorOperatingSystemVersion;
    WORD    MinorOperatingSystemVersion;
    WORD    MajorImageVersion;
    WORD    MinorImageVersion;
    WORD    MajorSubsystemVersion;
    WORD    MinorSubsystemVersion;
    DWORD   Win32VersionValue;
    DWORD   SizeOfImage;
    DWORD   SizeOfHeaders;
    DWORD   CheckSum;
    WORD    Subsystem;
    WORD    DllCharacteristics;
    DWORD   SizeOfStackReserve;
    DWORD   SizeOfStackCommit;
    DWORD   SizeOfHeapReserve;
    DWORD   SizeOfHeapCommit;
    DWORD   LoaderFlags;
    DWORD   NumberOfRvaAndSizes;
    IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
} IMAGE_OPTIONAL_HEADER32, *PIMAGE_OPTIONAL_HEADER32;

typedef struct _IMAGE_NT_HEADERS {
    DWORD Signature;
    IMAGE_FILE_HEADER FileHeader;
    IMAGE_OPTIONAL_HEADER32 OptionalHeader;
} IMAGE_NT_HEADERS32, *PIMAGE_NT_HEADERS32;
typedef IMAGE_NT_HEADERS32                  IMAGE_NT_HEADERS;
typedef PIMAGE_NT_HEADERS32                 PIMAGE_NT_HEADERS;

#define IMAGE_DIRECTORY_ENTRY_EXPORT          0   // Export Directory

typedef struct _IMAGE_EXPORT_DIRECTORY {
    DWORD   Characteristics;
    DWORD   TimeDateStamp;
    WORD    MajorVersion;
    WORD    MinorVersion;
    DWORD   Name;
    DWORD   Base;
    DWORD   NumberOfFunctions;
    DWORD   NumberOfNames;
    DWORD   AddressOfFunctions;     // RVA from base of image
    DWORD   AddressOfNames;         // RVA from base of image
    DWORD   AddressOfNameOrdinals;  // RVA from base of image
} IMAGE_EXPORT_DIRECTORY, *PIMAGE_EXPORT_DIRECTORY;

NTHALAPI
VOID
HalDisplayString (
    PUCHAR String
    );

NTHALAPI
VOID
HalQueryDisplayParameters (
    OUT PULONG WidthInCharacters,
    OUT PULONG HeightInLines,
    OUT PULONG CursorColumn,
    OUT PULONG CursorRow
    );

NTHALAPI
VOID
HalSetDisplayParameters (
    IN ULONG CursorColumn,
    IN ULONG CursorRow
    );

#endif //__NTDDK_EX__H__
